#ifndef SCENE_H_
#define SCENE_H_

#include <vector>
#include "mesh.h"
#include "snode.h"
#include "texture.h"

enum {
	SCNLOAD_FLIPYZ = 1,
	SCNLOAD_FLIPTEX = 2
};

class Scene {
private:
	bool own_texset;

public:
	std::vector<Mesh*> meshes;
	std::vector<Object*> objects;
	SceneNode *nodes;

	TextureSet *texset;

	explicit Scene(TextureSet *tset = 0);
	~Scene();

	Scene(const Scene &rhs) = delete;
	Scene &operator =(const Scene &rhs) = delete;

	void destroy();

	bool load(const char *fname, unsigned int flags = 0);

	void update(float dt);
	void draw() const;
};

#endif	// SCENE_H_
